#include <stdio.h>
#include <unistd.h>

#define LUA_LIB


#include "lua.h"
#include "lauxlib.h"

static int librobot_printchar(lua_State *L) 
{
  printf("%s\r", luaL_checkstring(L, 1));
  return 1;
}

static int librobot_sleep(lua_State *L) 
{
  unsigned int msec = (unsigned int)lua_tointeger(L, 1);
  int res = usleep(msec*1000);
  lua_pushnumber(L, res);
  return 1;
}

static int librobot_forward(lua_State *L) 
{
  printf("forward: %d step\n", luaL_checkinteger(L, 1));
  return 0;
}

static int librobot_backward(lua_State *L) 
{
  printf("backward: %d step\n", luaL_checkinteger(L, 1));
  return 0;
}

static int librobot_leftturn(lua_State *L) 
{
  printf("leftturn\n");
  return 0;
}

static int librobot_rightturn(lua_State *L) 
{
  printf("rightturn\n");
  return 0;
}

static int librobot_scanning(lua_State *L) 
{
  time_t t;  
  printf("scanning\n");
  srand((unsigned) time(&t));
  lua_pushnumber(L, rand()%2);
  return 1;
}

static const luaL_Reg librobot[] = {
  {"print_char", librobot_printchar},
  {"sleep",      librobot_sleep},
  {"forward",    librobot_forward},
  {"backward",   librobot_backward},
  {"leftturn",   librobot_leftturn},
  {"rightturn",  librobot_rightturn},
  {"scanning",   librobot_scanning},
  {NULL, NULL}
};

LUAMOD_API int luaopen_robot(lua_State *L) 
{
  luaL_newlib(L, librobot);
  return 1;
}